Option Compare Binary
Option Explicit On 
Option Strict On

Imports System
Imports System.Reflection

Public Class RemoteLoaderFactory
    Inherits MarshalByRefObject

    Private Const bfi As BindingFlags = _
        BindingFlags.Instance Or _
        BindingFlags.Public Or _
        BindingFlags.CreateInstance

    Public Function Create( _
        ByVal AssemblyFile As String, _
        ByVal TypeName As String, _
        ByVal Args() As Object _
    ) As IRemoteInterface
        Return _
            DirectCast( _
                Activator.CreateInstanceFrom( _
                    AssemblyFile, _
                    TypeName, _
                    False, _
                    bfi, _
                    Nothing, _
                    Args, _
                    Nothing, _
                    Nothing, _
                    Nothing _
                ).Unwrap, _
                IRemoteInterface _
            )
    End Function
End Class